
//
//  SinglePickerView.m
//  FollowMeLearningPickerView
//
//  Created by LBS_ios1 on 2017/12/19.
//  Copyright © 2017年 http://www.jianshu.com/u/8acc5c21e350. All rights reserved.
//

#import "SinglePickerView.h"
#import "Header.h"

@interface SinglePickerView ()
@property(nonatomic,strong)UIPickerView *pickerView;
@property(nonatomic,strong)NSMutableArray *totalArray;
@property(nonatomic,strong)NSMutableArray *ProvinceArray;


@end


@implementation SinglePickerView


-(instancetype)initWithFrame:(CGRect)frame
{
    if (self=[super initWithFrame:frame]) {
        
        
        NSString *filePath= [[NSBundle mainBundle]pathForResource:@"Province" ofType:@"plist"];
        
        
        NSArray *array=[NSArray arrayWithContentsOfFile:filePath];
        
        
        [array enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
            
            
            NSDictionary *dic=(NSDictionary *)obj;
            NSString *string=dic[@"name"];
            [self.ProvinceArray addObject:string];
            
            
        }];
        
        
        [self addSubview:self.pickerView];
    }
    return self;
}
-(NSMutableArray *)ProvinceArray
{
    if (!_ProvinceArray) {
        _ProvinceArray=[[NSMutableArray alloc]init];
    }
    return _ProvinceArray;
}
#pragma mark ===== UIPickerView
-(UIPickerView *)pickerView
{
    if (!_pickerView) {
        _pickerView=[[UIPickerView alloc]init];
        _pickerView.backgroundColor=[UIColor whiteColor];
        _pickerView.delegate = self;
        _pickerView.dataSource = self;
        _pickerView.showsSelectionIndicator = YES;
        
    }
    return _pickerView;
}

-(NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView
{
    return 1;
}
-(NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component
{
    
    
    return self.ProvinceArray.count;
    
}

- (nullable NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component
{
    return self.ProvinceArray[row];
    
}
#pragma mark ===== 每列宽度
- (CGFloat)pickerView:(UIPickerView *)pickerView widthForComponent:(NSInteger)component {
    
    return YHScreenWith;
}

#pragma mark ===== 行高
- (CGFloat)pickerView:(UIPickerView *)pickerView rowHeightForComponent:(NSInteger)component
{
    return 40;
}




#pragma mark ===== 返回选中的行
- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component{
    
    NSString *str=self.ProvinceArray[row];
    
    
    
}


#pragma mark ===== 自定义显示的view
- (UIView *)pickerView:(UIPickerView *)pickerView viewForRow:(NSInteger)row forComponent:(NSInteger)component reusingView:(UIView *)view {
    UILabel* pickerLabel = (UILabel*)view;
    if (!pickerLabel){
        pickerLabel = [[UILabel alloc] init];
        pickerLabel.adjustsFontSizeToFitWidth = YES;
        pickerLabel.textColor=[UIColor redColor];
        pickerLabel.textAlignment = NSTextAlignmentCenter;
        [pickerLabel setBackgroundColor:[UIColor clearColor]];
        [pickerLabel setFont:[UIFont boldSystemFontOfSize:18]];
    }
    
    //设置分割线的颜色
    for(UIView *singleLine in pickerView.subviews)
    {
        if (singleLine.frame.size.height < 1)
        {
            singleLine.backgroundColor = [UIColor greenColor];
        }
    }
    pickerLabel.text = [self pickerView:pickerView titleForRow:row forComponent:component];
    return pickerLabel;
}

- (nullable UIView *)viewForRow:(NSInteger)row forComponent:(NSInteger)component{
    
    UIView *view=[[UIView alloc]init];
    view.backgroundColor=[UIColor magentaColor];
    
    
    return view;
    
}


-(void)layoutSubviews
{
    
    self.pickerView.frame =CGRectMake(0, YHScreenHeight-300, YHScreenWith, 300);
    
}

-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event
{
    [self removeFromSuperview];
    
}





@end
